paddle_build.sh 43.9 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
#!/usr/bin/env bash

# Copyright (c) 2018 PaddlePaddle Authors. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#=================================================
#                   Utils
#=================================================

21 22
set -ex

23 24
function print_usage() {
    echo -e "\n${RED}Usage${NONE}:
25
    ${BOLD}${SCRIPT_NAME}${NONE} [OPTION]"
Q
Qiyang Min 已提交
26

27 28 29
    echo -e "\n${RED}Options${NONE}:
    ${BLUE}build${NONE}: run build for x86 platform
    ${BLUE}test${NONE}: run all unit tests
30
    ${BLUE}single_test${NONE}: run a single unit test
31 32
    ${BLUE}bind_test${NONE}: parallel tests bind to different GPU
    ${BLUE}doc${NONE}: generate paddle documents
33
    ${BLUE}gen_doc_lib${NONE}: generate paddle documents library
34 35 36 37
    ${BLUE}html${NONE}: convert C++ source code into HTML
    ${BLUE}dockerfile${NONE}: generate paddle release dockerfile
    ${BLUE}fluid_inference_lib${NONE}: deploy fluid inference library
    ${BLUE}check_style${NONE}: run code style check
L
Lei Wang 已提交
38
    ${BLUE}cicheck${NONE}: run CI tasks
39
    ${BLUE}assert_api_not_changed${NONE}: check api compability
40 41 42 43
    "
}

function init() {
44 45 46 47 48
    RED='\033[0;31m'
    BLUE='\033[0;34m'
    BOLD='\033[1m'
    NONE='\033[0m'

49
    PADDLE_ROOT="$( cd "$( dirname "${BASH_SOURCE[0]}")/../../" && pwd )"
50 51 52
    if [ -z "${SCRIPT_NAME}" ]; then
        SCRIPT_NAME=$0
    fi
53 54
}

55
function cmake_base() {
56 57 58 59 60 61 62 63
    # build script will not fail if *.deb does not exist
    rm *.deb 2>/dev/null || true
    # delete previous built whl packages
    rm -rf python/dist 2>/dev/null || true

    # Support build for all python versions, currently
    # including cp27-cp27m and cp27-cp27mu.
    PYTHON_FLAGS=""
64
    SYSTEM=`uname -s`
J
Jiabin Yang 已提交
65
    if [ "$SYSTEM" == "Darwin" ]; then
V
velconia 已提交
66
        echo "Using python abi: $1"
J
Jiabin Yang 已提交
67
        if [[ "$1" == "cp27-cp27m" ]] || [[ "$1" == "" ]]; then
68 69 70
            if [ -d "/Library/Frameworks/Python.framework/Versions/2.7" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/2.7
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/2.7
J
Jiabin Yang 已提交
71
                export PATH=/Library/Frameworks/Python.framework/Versions/2.7/bin/:${PATH}
72 73
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/2.7/bin/python2.7
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/2.7/include/python2.7
J
Jiabin Yang 已提交
74
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/2.7/lib/libpython2.7.dylib"
75
            pip install --user -r ${PADDLE_ROOT}/python/requirements.txt
76 77 78
            else
                exit 1
            fi
V
velconia 已提交
79
        elif [ "$1" == "cp35-cp35m" ]; then
V
velconia 已提交
80
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.5" ]; then
V
velconia 已提交
81 82 83 84 85 86
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.5/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.5/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.5/include/python3.5m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/libpython3.5m.dylib"
87
                pip3.5 uninstall -y protobuf
88
                pip3.5 install --user -r ${PADDLE_ROOT}/python/requirements.txt
V
velconia 已提交
89 90 91
            else
                exit 1
            fi
M
minqiyang 已提交
92 93 94 95 96 97 98 99
        elif [ "$1" == "cp36-cp36m" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.6" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.6/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.6/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.6/include/python3.6m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/libpython3.6m.dylib"
100
                pip3.6 uninstall -y protobuf
101
                pip3.6 install --user -r ${PADDLE_ROOT}/python/requirements.txt
M
minqiyang 已提交
102 103 104 105 106 107 108 109 110 111 112
            else
                exit 1
            fi
        elif [ "$1" == "cp37-cp37m" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.7" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.7/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.7/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.7/include/python3.7m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/libpython3.7m.dylib"
113
                pip3.7 uninstall -y protobuf
114
                pip3.7 install --user -r ${PADDLE_ROOT}/python/requirements.txt
M
minqiyang 已提交
115 116 117
            else
                exit 1
            fi
118
        fi
M
minqiyang 已提交
119
    else
120
        if [ "$1" != "" ]; then
M
minqiyang 已提交
121
            echo "using python abi: $1"
122 123 124 125 126 127
            if [ "$1" == "cp27-cp27m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.11-ucs2/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.11-ucs4/lib:}
                export PATH=/opt/python/cp27-cp27m/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27m/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27m/include/python2.7
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.11-ucs2/lib/libpython2.7.so"
128
                pip uninstall -y protobuf
129
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
130 131 132 133 134 135
            elif [ "$1" == "cp27-cp27mu" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.11-ucs4/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.11-ucs2/lib:}
                export PATH=/opt/python/cp27-cp27mu/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27mu/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27mu/include/python2.7
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.11-ucs4/lib/libpython2.7.so"
136
                pip uninstall -y protobuf
137
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
138 139 140 141
            elif [ "$1" == "cp35-cp35m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.5.1/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.5.1/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.5.1/bin/python3
M
minqiyang 已提交
142 143
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.5.1/include/python3.5m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.5.1/lib/libpython3.so"
144
                pip3.5 uninstall -y protobuf
145
                pip3.5 install -r ${PADDLE_ROOT}/python/requirements.txt
146 147 148 149 150 151
            elif [ "$1" == "cp36-cp36m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.6.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.6.0/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.6.0/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.6.0/include/python3.6m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.6.0/lib/libpython3.so"
152
                pip3.6 uninstall -y protobuf
153
                pip3.6 install -r ${PADDLE_ROOT}/python/requirements.txt
154 155 156
            elif [ "$1" == "cp37-cp37m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.7.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.7.0/bin/:${PATH}
157
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.7.0/bin/python3.7
158 159
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.7.0/include/python3.7m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.7.0/lib/libpython3.so"
160
                pip3.7 uninstall -y protobuf
161
                pip3.7 install -r ${PADDLE_ROOT}/python/requirements.txt
162
           fi
163 164 165
        else
            pip uninstall -y protobuf
            pip install -r ${PADDLE_ROOT}/python/requirements.txt
166 167
        fi
    fi
M
minqiyang 已提交
168

J
JiabinYang 已提交
169
    if [ "$SYSTEM" == "Darwin" ]; then
170 171
        WITH_DISTRIBUTE=${WITH_DISTRIBUTE:-ON}
        WITH_AVX=${WITH_AVX:-ON}
J
Jiabin Yang 已提交
172
        INFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR:-~/.cache/inference_demo}
J
JiabinYang 已提交
173
    else
J
Jiabin Yang 已提交
174
        INFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR:-/root/.cache/inference_demo}
175
    fi
M
minqiyang 已提交
176

G
gongweibao 已提交
177 178 179
    distibuted_flag=${WITH_DISTRIBUTE:-OFF}
    grpc_flag=${WITH_GRPC:-${distibuted_flag}}

180 181 182 183 184 185 186 187
    cat <<EOF
    ========================================
    Configuring cmake in /paddle/build ...
        -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE:-Release}
        ${PYTHON_FLAGS}
        -DWITH_DSO=ON
        -DWITH_GPU=${WITH_GPU:-OFF}
        -DWITH_AMD_GPU=${WITH_AMD_GPU:-OFF}
G
gongweibao 已提交
188
        -DWITH_DISTRIBUTE=${distibuted_flag}
189
        -DWITH_MKL=${WITH_MKL:-ON}
B
baojun-nervana 已提交
190
        -DWITH_NGRAPH=${WITH_NGRAPH:-OFF}
191 192 193
        -DWITH_AVX=${WITH_AVX:-OFF}
        -DWITH_GOLANG=${WITH_GOLANG:-OFF}
        -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-All}
194
        -DCUDA_ARCH_BIN=${CUDA_ARCH_BIN}
195 196 197
        -DWITH_PYTHON=${WITH_PYTHON:-ON}
        -DCUDNN_ROOT=/usr/
        -DWITH_TESTING=${WITH_TESTING:-ON}
198
        -DWITH_COVERAGE=${WITH_COVERAGE:-OFF}
199 200 201 202 203
        -DCMAKE_MODULE_PATH=/opt/rocm/hip/cmake
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
        -DWITH_CONTRIB=${WITH_CONTRIB:-ON}
        -DWITH_INFERENCE_API_TEST=${WITH_INFERENCE_API_TEST:-ON}
204
        -DWITH_HIGH_LEVEL_API_TEST=${WITH_HIGH_LEVEL_API_TEST:-OFF}
205
        -DINFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR}
206
        -DPY_VERSION=${PY_VERSION:-2.7}
W
Wu Yi 已提交
207
        -DCMAKE_INSTALL_PREFIX=${INSTALL_PREFIX:-/paddle/build}
G
gongweibao 已提交
208
        -DWITH_GRPC=${grpc_flag}
209
    ========================================
210
EOF
211 212 213 214 215 216 217 218 219
    # Disable UNITTEST_USE_VIRTUALENV in docker because
    # docker environment is fully controlled by this script.
    # See /Paddle/CMakeLists.txt, UNITTEST_USE_VIRTUALENV option.
    cmake .. \
        -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE:-Release} \
        ${PYTHON_FLAGS} \
        -DWITH_DSO=ON \
        -DWITH_GPU=${WITH_GPU:-OFF} \
        -DWITH_AMD_GPU=${WITH_AMD_GPU:-OFF} \
G
gongweibao 已提交
220
        -DWITH_DISTRIBUTE=${distibuted_flag} \
221
        -DWITH_MKL=${WITH_MKL:-ON} \
B
baojun-nervana 已提交
222
        -DWITH_NGRAPH=${WITH_NGRAPH:-OFF} \
223
        -DWITH_AVX=${WITH_AVX:-OFF} \
224
        -DNOAVX_CORE_FILE=${NOAVX_CORE_FILE:-""} \
225 226
        -DWITH_GOLANG=${WITH_GOLANG:-OFF} \
        -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-All} \
227
        -DCUDA_ARCH_BIN=${CUDA_ARCH_BIN} \
228 229 230
        -DWITH_PYTHON=${WITH_PYTHON:-ON} \
        -DCUDNN_ROOT=/usr/ \
        -DWITH_TESTING=${WITH_TESTING:-ON} \
231
        -DWITH_COVERAGE=${WITH_COVERAGE:-OFF} \
232 233 234 235
        -DCMAKE_MODULE_PATH=/opt/rocm/hip/cmake \
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON \
        -DWITH_CONTRIB=${WITH_CONTRIB:-ON} \
        -DWITH_INFERENCE_API_TEST=${WITH_INFERENCE_API_TEST:-ON} \
236
        -DWITH_HIGH_LEVEL_API_TEST=${WITH_HIGH_LEVEL_API_TEST:-OFF} \
J
Jiabin Yang 已提交
237
        -DINFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR} \
W
Wu Yi 已提交
238
        -DPY_VERSION=${PY_VERSION:-2.7} \
M
minqiyang 已提交
239
        -DCMAKE_INSTALL_PREFIX=${INSTALL_PREFIX:-/paddle/build} \
G
gongweibao 已提交
240
        -DWITH_GRPC=${grpc_flag}
J
JiabinYang 已提交
241

242 243
}

244 245 246 247 248 249
function cmake_gen() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cmake_base $1
}

250 251 252 253 254 255 256 257 258 259
function abort(){
    echo "Your change doesn't follow PaddlePaddle's code style." 1>&2
    echo "Please use pre-commit to check what is wrong." 1>&2
    exit 1
}

function check_style() {
    trap 'abort' 0
    set -e

260 261 262
    if [ -x "$(command -v gimme)" ]; then
    	eval "$(GIMME_GO_VERSION=1.8.3 gimme)"
    fi
263

T
Tao Luo 已提交
264
    pip install cpplint
265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284
    # set up go environment for running gometalinter
    mkdir -p $GOPATH/src/github.com/PaddlePaddle/
    ln -sf ${PADDLE_ROOT} $GOPATH/src/github.com/PaddlePaddle/Paddle

    export PATH=/usr/bin:$PATH
    pre-commit install
    clang-format --version

    if ! pre-commit run -a ; then
        git diff
        exit 1
    fi

    trap : 0
}

#=================================================
#              Build
#=================================================

285
function build_base() {
286 287 288 289 290 291
    if [ "$SYSTEM" == "Linux" ];then
      parallel_number=`nproc`
    else
      parallel_number=8
    fi
    if [ "$1" != "" ]; then
292 293 294 295
      parallel_number=$1
    fi
    make clean
    make -j ${parallel_number}
296
    make install -j ${parallel_number}
297 298 299
}


300 301 302 303 304 305 306 307
function build() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ============================================
    Building in /paddle/build ...
    ============================================
EOF
308
    build_base $1
309 310
}

311 312 313 314 315 316 317 318 319
function build_mac() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ============================================
    Building in /paddle/build ...
    ============================================
EOF
    make clean
J
JiabinYang 已提交
320 321
    make -j 8
    make install -j 8
322 323
}

324 325 326 327 328 329 330 331 332
function run_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit tests ...
    ========================================
EOF
333 334 335 336 337
        if [ ${TESTING_DEBUG_MODE:-OFF} == "ON" ] ; then
            ctest -V
        else
            ctest --output-on-failure
        fi
338 339 340
    fi
}

341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359

function combine_avx_noavx_build() {
    mkdir -p ${PADDLE_ROOT}/build.noavx
    cd ${PADDLE_ROOT}/build.noavx
    WITH_AVX=OFF
    cmake_base ${PYTHON_ABI:-""}
    build_base

    # build combined one
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    NOAVX_CORE_FILE=`find ${PADDLE_ROOT}/build.noavx/python/paddle/fluid/ -name "core_noavx.*"`
    WITH_AVX=ON

    cmake_base ${PYTHON_ABI:-""}
    build_base
}


G
gongweibao 已提交
360 361 362 363 364 365 366 367 368 369 370 371
function run_brpc_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [[ ${WITH_TESTING:-ON} == "ON" \
        && ${WITH_DISTRIBUTE:-OFF} == "ON" \
        && ${WITH_GRPC:-OFF} == "OFF" ]] ; then
    cat <<EOF
    ========================================
    Running brpc unit tests ...
    ========================================
EOF
        set +x
372 373
        declare -a other_tests=("test_listen_and_serv_op" "system_allocator_test" \
        "rpc_server_test" "varhandle_test" "collective_server_test" "brpc_serde_test")
G
gongweibao 已提交
374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399
        all_tests=`ctest -N`

        for t in "${other_tests[@]}"
        do
            if [[ ${all_tests} != *$t* ]]; then
                continue
            fi

            if [[ ${TESTING_DEBUG_MODE:-OFF} == "ON" ]] ; then
                ctest -V -R $t
            else
                ctest --output-on-failure -R $t
            fi
        done
        set -x

        if [[ ${TESTING_DEBUG_MODE:-OFF} == "ON" ]] ; then
            ctest -V -R test_dist_*
        else
            ctest --output-on-failure -R test_dist_*
        fi
    fi
}



400 401 402 403 404 405 406 407 408
function run_mac_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit tests ...
    ========================================
EOF
J
JiabinYang 已提交
409 410 411
        #remove proxy here to fix dist error on mac
        export http_proxy=
        export https_proxy=
M
minqiyang 已提交
412
        # make install should also be test when unittest
413
        make install -j 8
414 415 416 417 418 419 420 421 422 423 424 425 426

        set +ex
        if [ "$1" == "cp27-cp27m" ]; then
            pip uninstall -y paddlepaddle
        elif [ "$1" == "cp35-cp35m" ]; then
            pip3.5 uninstall -y paddlepaddle
        elif [ "$1" == "cp36-cp36m" ]; then
            pip3.6 uninstall -y paddlepaddle
        elif [ "$1" == "cp37-cp37m" ]; then
            pip3.7 uninstall -y paddlepaddle
        fi
        set -ex

427
        if [ "$1" == "cp27-cp27m" ]; then
428
            set -e
429
            pip install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
J
JiabinYang 已提交
430
            python ${PADDLE_ROOT}/paddle/scripts/installation_validate.py
431 432 433 434 435 436 437
        elif [ "$1" == "cp35-cp35m" ]; then
            pip3.5 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
        elif [ "$1" == "cp36-cp36m" ]; then
            pip3.6 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
        elif [ "$1" == "cp37-cp37m" ]; then
            pip3.7 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
        fi
M
minqiyang 已提交
438

439 440 441
        # TODO: jiabin need to refine this part when these tests fixed on mac
        ctest --output-on-failure -j $2

T
Tao Luo 已提交
442
        paddle version
443 444 445
    fi
}

Y
yuyang18 已提交
446 447 448 449 450 451
function assert_api_not_changed() {
    mkdir -p ${PADDLE_ROOT}/build/.check_api_workspace
    cd ${PADDLE_ROOT}/build/.check_api_workspace
    virtualenv .env
    source .env/bin/activate
    pip install ${PADDLE_ROOT}/build/python/dist/*whl
452
    python ${PADDLE_ROOT}/tools/print_signatures.py paddle.fluid > new.spec
453

454
    if [ "$1" == "cp35-cp35m" ] || [ "$1" == "cp36-cp36m" ] || [ "$1" == "cp37-cp37m" ]; then
M
minqiyang 已提交
455 456
        # Use sed to make python2 and python3 sepc keeps the same
        sed -i 's/arg0: str/arg0: unicode/g' new.spec
457
        sed -i "s/\(.*Transpiler.*\).__init__ (ArgSpec(args=\['self'].*/\1.__init__ /g" new.spec
M
minqiyang 已提交
458
    fi
X
fix  
Xin Pan 已提交
459 460 461
    # ComposeNotAligned has significant difference between py2 and py3
    sed -i '/.*ComposeNotAligned.*/d' new.spec

462
    python ${PADDLE_ROOT}/tools/diff_api.py ${PADDLE_ROOT}/paddle/fluid/API.spec new.spec
S
sneaxiy 已提交
463 464

    # Currently, we only check in PR_CI python 2.7
S
sneaxiy 已提交
465 466 467 468
    if [ "$SYSTEM" != "Darwin" ]; then
      if [ "$1" == "" ] || [ "$1" == "cp27-cp27m" ] || [ "$1" == "cp27-cp27mu" ]; then
        python ${PADDLE_ROOT}/tools/diff_use_default_grad_op_maker.py ${PADDLE_ROOT}/paddle/fluid/op_use_default_grad_op_maker.spec
      fi
S
sneaxiy 已提交
469
    fi
Y
yuyang18 已提交
470
    deactivate
471 472 473 474 475 476
}

function assert_api_spec_approvals() {
    if [ -z ${BRANCH} ]; then
        BRANCH="develop"
    fi
477

T
tianshuo78520a 已提交
478 479
    API_FILES=("CMakeLists.txt"
               "paddle/fluid/API.spec"
S
sneaxiy 已提交
480
               "paddle/fluid/op_use_default_grad_op_maker.spec"
X
Xin Pan 已提交
481 482
               "paddle/fluid/framework/operator.h"
               "paddle/fluid/framework/tensor.h"
S
sneaxiy 已提交
483 484
               "paddle/fluid/framework/details/op_registry.h"
               "paddle/fluid/framework/grad_op_desc_maker.h"
X
Xin Pan 已提交
485 486 487 488 489 490 491
               "paddle/fluid/framework/lod_tensor.h"
               "paddle/fluid/framework/selected_rows.h"
               "paddle/fluid/framework/op_desc.h"
               "paddle/fluid/framework/block_desc.h"
               "paddle/fluid/framework/var_desc.h"
               "paddle/fluid/framework/scope.h"
               "paddle/fluid/framework/ir/node.h"
X
Xin Pan 已提交
492 493
               "paddle/fluid/framework/ir/graph.h"
               "paddle/fluid/framework/framework.proto"
494
               "python/requirements.txt"
T
tianshuo78520a 已提交
495
               "python/paddle/fluid/__init__.py"
C
chengduo 已提交
496 497 498 499
               "python/paddle/fluid/compiler.py"
               "python/paddle/fluid/parallel_executor.py"
               "python/paddle/fluid/framework.py"
               "python/paddle/fluid/backward.py"
X
Xin Pan 已提交
500
               "paddle/fluid/operators/distributed/send_recv.proto.in")
501 502

    approval_line=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000`
503 504 505 506 507 508 509 510 511 512
    git_files=`git diff --numstat upstream/$BRANCH| wc -l`
    git_count=`git diff --numstat upstream/$BRANCH| awk '{sum+=$1}END{print sum}'`
    
    if [[ "$git_files" > 19 || "$git_count" > 999 ]];then
      APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 5086632`
      if [ "${APPROVALS}" == "FALSE" ]; then
        echo "You must have Dianhai approval for change 20+ files or add than 1000+ lines of content"
      fi
    fi    

X
fix  
Xin Pan 已提交
513
    for API_FILE in ${API_FILES[*]}; do
T
tianshuo78520a 已提交
514
      API_CHANGE=`git diff --name-only upstream/$BRANCH | grep "${API_FILE}" | grep -v "/CMakeLists.txt" || true`
X
Xin Pan 已提交
515
      echo "checking ${API_FILE} change, PR: ${GIT_PR_ID}, changes: ${API_CHANGE}"
516
      if [ "${API_CHANGE}" ] && [ "${GIT_PR_ID}" != "" ]; then
X
Xin Pan 已提交
517
          # NOTE: per_page=10000 should be ok for all cases, a PR review > 10000 is not human readable.
518
          # approval_user_list: XiaoguangHu01 46782768,chengduoZH 30176695,Xreki 12538138,luotao1 6836917,sneaxiy 32832641,tensor-tang 21351065,xsrobin 50069408,qingqing01 7845005,guoshengCS 14105589,heavengate 12605721,kuke 3064195,Superjomn 328693,lanxianghit 47554610,cyj1986 39645414,hutuxian 11195205,frankwhzhang 20274488,nepeplwu 45024560,Dianhai 5086632,JiabinYang 22361972,chenwhql 22561442. 
519
          if [ "${API_FILE}" == "paddle/fluid/API.spec" ];then
520
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 2 7534971 14105589 12605721 3064195 328693 47554610 39645414 11195205 20274488 45024560 ` 
521 522
          elif [ "${API_FILE}" == "paddle/fluid/op_use_default_grad_op_maker.spec" ];then
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 32832641 6836917`
523
          elif [ "${API_FILE}" == "CMakeLists.txt" ];then
524
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 6836917 46782768 30176695`
T
tianshuo78520a 已提交
525
          elif [ "${API_FILE}" == "python/paddle/fluid/__init__.py" ];then
526
             APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 6836917 47554610`
527
          elif [ "${API_FILE}" == "python/requirements.txt" ];then
528
             APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 6836917 22361972`
529
          else
530
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 21351065 3048612 46782768 30176695 12538138 6836917 32832641`
531
          fi
X
Xin Pan 已提交
532 533
          echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
          if [ "${APPROVALS}" == "FALSE" ]; then
534
            if [ "${API_FILE}" == "paddle/fluid/API.spec" ];then
535
              echo "You must have two RD (wanghaoshuang or guoshengCS or heavengate or kuke or Superjomn or lanxianghit or cyj1986 or hutuxian or frankwhzhang or nepeplwu) approval for the api change! ${API_FILE} for the management reason of API interface and API document."
536
            elif [ "${API_FILE}" == "paddle/fluid/op_use_default_grad_op_maker.spec" ];then
537
              echo "You must have one RD (sneaxiy (Recommend) or luotao1) approval for the api change! ${API_FILE} for the management of grad_op memory optimization."
538
            elif [ "${API_FILE}" == "CMakeLists.txt" ];then
539
              echo "You must have one RD (luotao1 or chengduoZH or XiaoguangHu01) approval for the cmakelist change! ${API_FILE} for the management reason of the Compilation parameter."
540
            elif [ "${API_FILE}" == "python/requirements.txt" ];then
541
              echo "You must have one RD (JiabinYang (Recommend) or luotao1) approval for the python/requirements.txt change! ${API_FILE} for the management reason of the Compilation parameter."
T
tianshuo78520a 已提交
542
            elif [ "${API_FILE}" == "python/paddle/fluid/__init__.py" ];then
543
              echo "You must have one RD (lanxianghit (Recommend) or luotao1) approval for the python/paddle/fluid/__init__.py change! ${API_FILE} for the management reason of the environment variables."
544
            else
545
              echo "You must have one RD (XiaoguangHu01,chengduoZH,Xreki,luotao1,sneaxiy,tensor-tang) approval for the api change! ${API_FILE} for the management reason of the underlying code for fluid."
546 547
            fi
            exit 1
X
Xin Pan 已提交
548 549 550
          fi
      fi
    done
551

X
fix  
Xin Pan 已提交
552
    HAS_CONST_CAST=`git diff -U0 upstream/$BRANCH |grep -o -m 1 "const_cast" || true`
553 554
    if [ ${HAS_CONST_CAST} ] && [ "${GIT_PR_ID}" != "" ]; then
        APPROVALS=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000 | \
T
tianshuo78520a 已提交
555
        python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 21351065 3048612 46782768 30176695 12538138 6836917 32832641`
556 557
        echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
        if [ "${APPROVALS}" == "FALSE" ]; then
558
            echo "You must have one RD (XiaoguangHu01,chengduoZH,Xreki,luotao1,sneaxiy,tensor-tang) approval for the usage (either add or delete) of const_cast."
X
Xin Pan 已提交
559
            exit 1
560 561
        fi
    fi
562 563 564 565 566 567 568 569 570 571 572
    
    HAS_DEFINE_FLAG=`git diff -U0 upstream/$BRANCH |grep -o -m 1 "DEFINE_int32" |grep -o -m 1 "DEFINE_bool" | grep -o -m 1 "DEFINE_string" || true`
    if [ ${HAS_DEFINE_FLAG} ] && [ "${GIT_PR_ID}" != "" ]; then
        APPROVALS=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000 | \
        python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 47554610` 
        echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
        if [ "${APPROVALS}" == "FALSE" ]; then
            echo "You must have one RD lanxianghit approval for the usage (either add or delete) of DEFINE_int32/DEFINE_bool/DEFINE_string flag."
            exit 1
        fi
    fi
573 574 575 576 577 578 579 580 581 582 583 584

    HAS_PADDLE_ENFORCE_FLAG=`git diff -U0 upstream/$BRANCH |grep -v "PADDLE_ENFORCE_" |grep -o -m 1 "PADDLE_ENFORCE" || true`
    if [ ${HAS_PADDLE_ENFORCE_FLAG} ] && [ "${GIT_PR_ID}" != "" ]; then
        APPROVALS=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000 | \
        python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 6836917 47554610 22561442`
        echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
        if [ "${APPROVALS}" == "FALSE" ]; then
            echo "PADDLE_ENFORCE will be deprecated soon. Please use PADDLE_ENFORCE_EQ/NE/GT/GE/LT/LE or PADDLE_ENFORCE_NOT_NULL instead."
            echo "You must have one RD (chenwhql (Recommend) , luotao1 (Recommend) or lanxianghit) approval for the usage (either add or delete) of PADDLE_ENFORCE. "
            exit 1
        fi
    fi
Y
yuyang18 已提交
585 586 587
}


588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606
function single_test() {
    TEST_NAME=$1
    if [ -z "${TEST_NAME}" ]; then
        echo -e "${RED}Usage:${NONE}"
        echo -e "${BOLD}${SCRIPT_NAME}${NONE} ${BLUE}single_test${NONE} [test_name]"
        exit 1
    fi
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running ${TEST_NAME} ...
    ========================================
EOF
        ctest --output-on-failure -R ${TEST_NAME}
    fi
}

607 608 609
function bind_test() {
    # the number of process to run tests
    NUM_PROC=6
Q
Qiyang Min 已提交
610

611 612 613
    # calculate and set the memory usage for each process
    MEM_USAGE=$(printf "%.2f" `echo "scale=5; 1.0 / $NUM_PROC" | bc`)
    export FLAGS_fraction_of_gpu_memory_to_use=$MEM_USAGE
Q
Qiyang Min 已提交
614

615 616
    # get the CUDA device count
    CUDA_DEVICE_COUNT=$(nvidia-smi -L | wc -l)
Q
Qiyang Min 已提交
617

618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636
    for (( i = 0; i < $NUM_PROC; i++ )); do
        cuda_list=()
        for (( j = 0; j < $CUDA_DEVICE_COUNT; j++ )); do
            s=$[i+j]
            n=$[s%CUDA_DEVICE_COUNT]
            if [ $j -eq 0 ]; then
                cuda_list=("$n")
            else
                cuda_list="$cuda_list,$n"
            fi
        done
        echo $cuda_list
        # CUDA_VISIBLE_DEVICES http://acceleware.com/blog/cudavisibledevices-masking-gpus
        # ctest -I https://cmake.org/cmake/help/v3.0/manual/ctest.1.html?highlight=ctest
        env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC --output-on-failure &
    done
    wait
}

637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698
EXIT_CODE=0;
function caught_error() {
 for job in `jobs -p`; do
        # echo "PID => ${job}"
        if ! wait ${job} ; then
            echo "At least one test failed with exit code => $?" ;
            EXIT_CODE=1;
        fi
    done
}

function card_test() {
    set -m

    # get the CUDA device count
    CUDA_DEVICE_COUNT=$(nvidia-smi -L | wc -l)

    testcases=$1
    if (( $# > 1 )); then
        cardnumber=$2
        if (( $cardnumber > $CUDA_DEVICE_COUNT )); then
            cardnumber=$CUDA_DEVICE_COUNT
        fi
    else
        cardnumber=$CUDA_DEVICE_COUNT
    fi

    if [[ "$testcases" == "" ]]; then
        return 0
    fi

    trap 'caught_error' CHLD

    NUM_PROC=$[CUDA_DEVICE_COUNT/$cardnumber]
    for (( i = 0; i < $NUM_PROC; i++ )); do
        # CUDA_VISIBLE_DEVICES http://acceleware.com/blog/cudavisibledevices-masking-gpus
        # ctest -I https://cmake.org/cmake/help/v3.0/manual/ctest.1.html?highlight=ctest
        cuda_list=()
        for (( j = 0; j < cardnumber; j++ )); do
            if [ $j -eq 0 ]; then
                    cuda_list=("$[i*cardnumber]")
                else
                    cuda_list="$cuda_list,$[i*cardnumber+j]"
            fi
        done
        if [ ${TESTING_DEBUG_MODE:-OFF} == "ON" ] ; then
            if [[ $cardnumber == $CUDA_DEVICE_COUNT ]]; then
                ctest -I $i,,$NUM_PROC -R "($testcases)" -V &
            else
                env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC -R "($testcases)" -V &
            fi
        else
            if [[ $cardnumber == $CUDA_DEVICE_COUNT ]]; then
                ctest -I $i,,$NUM_PROC -R "($testcases)" --output-on-failure &
            else
                # echo "env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC -R \"($testcases)\" --output-on-failure &"
                env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC -R "($testcases)" --output-on-failure &
            fi
        fi
    done

    wait; # wait for all subshells to finish
699
    set +m
700 701
}

702
function parallel_test_base() {
703 704 705
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
706
    Running unit tests in parallel way ...
707 708 709 710 711
    ========================================
EOF

set +x
        EXIT_CODE=0;
712 713 714 715 716 717
        test_cases=$(ctest -N -V) # get all test cases
        exclusive_tests=''        # cases list which would be run exclusively
        single_card_tests=''      # cases list which would take one graph card
        multiple_card_tests=''    # cases list which would take multiple GPUs, most cases would be two GPUs
        is_exclusive=''           # indicate whether the case is exclusive type
        is_multicard=''           # indicate whether the case is multiple GPUs type
718 719 720 721 722 723 724 725
        while read -r line; do
            if [[ "$line" == "" ]]; then
                continue
            fi
                read matchstr <<< $(echo "$line"|grep -oEi 'Test[ \t]+#')
                if [[ "$matchstr" == "" ]]; then
                    # Any test case with LABELS property would be parse here
                    # RUN_TYPE=EXCLUSIVE mean the case would run exclusively
726
                    # RUN_TYPE=DIST mean the case would take two graph GPUs during runtime
727 728 729 730 731 732 733
                    read is_exclusive <<< $(echo "$line"|grep -oEi "RUN_TYPE=EXCLUSIVE")
                    read is_multicard <<< $(echo "$line"|grep -oEi "RUN_TYPE=DIST")
                    continue
                fi
                read testcase <<< $(echo "$line"|grep -oEi "\w+$")

                if [[ "$is_multicard" == "" ]]; then
734
                  # trick: treat all test case with prefix "test_dist" as dist case, and would run on 2 GPUs
735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762
                  read is_multicard <<< $(echo "$testcase"|grep -oEi "test_dist")
                fi

                if [[ "$is_exclusive" != "" ]]; then
                    if [[ "$exclusive_tests" == "" ]]; then
                        exclusive_tests="^$testcase$"
                    else
                        exclusive_tests="$exclusive_tests|^$testcase$"
                    fi
                elif [[ "$is_multicard" != "" ]]; then
                    if [[ "$multiple_card_tests" == "" ]]; then
                        multiple_card_tests="^$testcase$"
                    else
                        multiple_card_tests="$multiple_card_tests|^$testcase$"
                    fi
                else
                    if [[ "$single_card_tests" == "" ]]; then
                        single_card_tests="^$testcase$"
                    else
                        single_card_tests="$single_card_tests|^$testcase$"
                    fi
                fi
                is_exclusive=''
                is_multicard=''
                matchstr=''
                testcase=''
        done <<< "$test_cases";

763 764 765
        card_test "$single_card_tests" 1    # run cases with single GPU
        card_test "$multiple_card_tests" 2  # run cases with two GPUs
        card_test "$exclusive_tests"        # run cases exclusively, in this cases would be run with 4/8 GPUs
766
        if [[ "$EXIT_CODE" != "0" ]]; then
767
            exit 8;
768 769 770 771 772
        fi
set -ex
    fi
}

773 774 775 776 777 778
function parallel_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    parallel_test_base
}

779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796
function gen_doc_lib() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ========================================
    Building documentation library ...
    In /paddle/build
    ========================================
EOF
    cmake .. \
        -DCMAKE_BUILD_TYPE=Release \
        -DWITH_GPU=OFF \
        -DWITH_MKL=OFF \

    local LIB_TYPE=$1
    case $LIB_TYPE in
      full)
        # Build full Paddle Python module. Will timeout without caching 'copy_paddle_pybind' first
797
        make -j `nproc` framework_py_proto copy_paddle_pybind paddle_python
798 799 800 801 802 803 804 805 806 807 808 809 810
        ;;
      pybind)
        # Build paddle pybind library. Takes 49 minutes to build. Might timeout
        make -j `nproc` copy_paddle_pybind
        ;;
      proto)
        # Even smaller library.
        make -j `nproc` framework_py_proto
        ;;
      *)
        exit 0
        ;;
      esac
811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829 830 831
}

function gen_html() {
    cat <<EOF
    ========================================
    Converting C++ source code into HTML ...
    ========================================
EOF
    export WOBOQ_OUT=${PADDLE_ROOT}/build/woboq_out
    mkdir -p $WOBOQ_OUT
    cp -rv /woboq/data $WOBOQ_OUT/../data
    /woboq/generator/codebrowser_generator \
    	-b ${PADDLE_ROOT}/build \
    	-a \
    	-o $WOBOQ_OUT \
    	-p paddle:${PADDLE_ROOT}
    /woboq/indexgenerator/codebrowser_indexgenerator $WOBOQ_OUT
}

function gen_dockerfile() {
    # Set BASE_IMAGE according to env variables
832 833
    CUDA_MAJOR="$(echo $CUDA_VERSION | cut -d '.' -f 1).$(echo $CUDA_VERSION | cut -d '.' -f 2)"
    CUDNN_MAJOR=$(echo $CUDNN_VERSION | cut -d '.' -f 1)
834
    if [[ ${WITH_GPU} == "ON" ]]; then
835
        BASE_IMAGE="nvidia/cuda:${CUDA_MAJOR}-cudnn${CUDNN_MAJOR}-runtime-ubuntu16.04"
836
    else
837
        BASE_IMAGE="ubuntu:16.04"
838 839 840 841
    fi

    DOCKERFILE_GPU_ENV=""
    DOCKERFILE_CUDNN_DSO=""
X
Xi Chen 已提交
842
    DOCKERFILE_CUBLAS_DSO=""
843 844
    if [[ ${WITH_GPU:-OFF} == 'ON' ]]; then
        DOCKERFILE_GPU_ENV="ENV LD_LIBRARY_PATH /usr/lib/x86_64-linux-gnu:\${LD_LIBRARY_PATH}"
X
Xi Chen 已提交
845
        DOCKERFILE_CUDNN_DSO="RUN ln -sf /usr/lib/x86_64-linux-gnu/libcudnn.so.${CUDNN_MAJOR} /usr/lib/x86_64-linux-gnu/libcudnn.so"
X
Xi Chen 已提交
846
        DOCKERFILE_CUBLAS_DSO="RUN ln -sf /usr/local/cuda/targets/x86_64-linux/lib/libcublas.so.${CUDA_MAJOR} /usr/lib/x86_64-linux-gnu/libcublas.so"
847 848 849 850
    fi

    cat <<EOF
    ========================================
851
    Generate ${PADDLE_ROOT}/build/Dockerfile ...
852 853 854 855 856 857 858 859 860 861
    ========================================
EOF

    cat > ${PADDLE_ROOT}/build/Dockerfile <<EOF
    FROM ${BASE_IMAGE}
    MAINTAINER PaddlePaddle Authors <paddle-dev@baidu.com>
    ENV HOME /root
EOF

    if [[ ${WITH_GPU} == "ON"  ]]; then
C
chengduo 已提交
862
        NCCL_DEPS="apt-get install -y --allow-change-held-packages libnccl2=2.4.7-1+cuda${CUDA_MAJOR} libnccl-dev=2.4.7-1+cuda${CUDA_MAJOR} || true"
863
    else
864
        NCCL_DEPS="true"
865 866
    fi

T
Tao Luo 已提交
867 868
    PADDLE_VERSION="paddle version"
    CMD='"paddle", "version"'
869

870 871 872 873 874 875
    if [ "$1" == "cp35-cp35m" ]; then
        cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
    ADD python/dist/*.whl /
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y wget python3 python3-pip libgtk2.0-dev dmidecode python3-tk && \
876
        pip3 install opencv-python py-cpuinfo==5.0.0 && pip3 install /*.whl; apt-get install -f -y && \
877 878 879 880 881 882 883
        apt-get clean -y && \
        rm -f /*.whl && \
        ${PADDLE_VERSION} && \
        ldconfig
    ${DOCKERFILE_CUDNN_DSO}
    ${DOCKERFILE_CUBLAS_DSO}
    ${DOCKERFILE_GPU_ENV}
884 885 886 887 888 889 890 891 892 893 894 895 896 897 898 899 900 901 902 903 904 905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927 928 929 930
EOF
    elif [ "$1" == "cp36-cp36m" ]; then
        cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
    ADD python/dist/*.whl /
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN mkdir -p /root/python_build/ && wget -q https://www.sqlite.org/2018/sqlite-autoconf-3250300.tar.gz && \
        tar -zxf sqlite-autoconf-3250300.tar.gz && cd sqlite-autoconf-3250300 && \
        ./configure -prefix=/usr/local && make -j8 && make install && cd ../ && rm sqlite-autoconf-3250300.tar.gz && \
        wget -q https://www.python.org/ftp/python/3.6.0/Python-3.6.0.tgz && \
        tar -xzf Python-3.6.0.tgz && cd Python-3.6.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
        make -j8 > /dev/null && make altinstall > /dev/null
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && \
        pip3.6 install opencv-python && pip3.6 install /*.whl; apt-get install -f -y && \
        apt-get clean -y && \
        rm -f /*.whl && \
        ${PADDLE_VERSION} && \
        ldconfig
    ${DOCKERFILE_CUDNN_DSO}
    ${DOCKERFILE_CUBLAS_DSO}
    ${DOCKERFILE_GPU_ENV}
EOF
    elif [ "$1" == "cp37-cp37m" ]; then
        cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
    ADD python/dist/*.whl /
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN wget -q https://www.python.org/ftp/python/3.7.0/Python-3.7.0.tgz && \
        tar -xzf Python-3.7.0.tgz && cd Python-3.7.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
        make -j8 > /dev/null && make altinstall > /dev/null
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && \
        pip3.7 install opencv-python && pip3.7 install /*.whl; apt-get install -f -y && \
        apt-get clean -y && \
        rm -f /*.whl && \
        ${PADDLE_VERSION} && \
        ldconfig
    ${DOCKERFILE_CUDNN_DSO}
    ${DOCKERFILE_CUBLAS_DSO}
    ${DOCKERFILE_GPU_ENV}
931 932 933
EOF
    else
        cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
934 935
    ADD python/dist/*.whl /
    # run paddle version to install python packages first
936 937
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y wget python-pip python-opencv libgtk2.0-dev dmidecode python-tk && easy_install -U pip && \
938 939 940 941 942 943
        pip install /*.whl; apt-get install -f -y && \
        apt-get clean -y && \
        rm -f /*.whl && \
        ${PADDLE_VERSION} && \
        ldconfig
    ${DOCKERFILE_CUDNN_DSO}
X
Xi Chen 已提交
944
    ${DOCKERFILE_CUBLAS_DSO}
945
    ${DOCKERFILE_GPU_ENV}
946
EOF
947 948
    fi

949
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
950 951 952 953 954
    # default command shows the paddle version and exit
    CMD [${CMD}]
EOF
}

955
function gen_fluid_lib() {
L
Lei Wang 已提交
956 957
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
T
Tao Luo 已提交
958
    cat <<EOF
959
    ========================================
960
    Generating fluid library for train and inference ...
961 962
    ========================================
EOF
963 964 965 966
    parallel_number=`nproc`
    if [[ "$1" != "" ]]; then
      parallel_number=$1
    fi
967 968
    cmake .. -DWITH_DISTRIBUTE=OFF -DON_INFER=ON -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-Auto} -DCUDA_ARCH_BIN=${CUDA_ARCH_BIN}

969 970
    make -j ${parallel_number} fluid_lib_dist
    make -j ${parallel_number} inference_lib_dist
T
Tao Luo 已提交
971 972
}

973
function tar_fluid_lib() {
T
Tao Luo 已提交
974
    cat <<EOF
T
Tao Luo 已提交
975
    ========================================
976
    Taring fluid library for train and inference ...
T
Tao Luo 已提交
977 978
    ========================================
EOF
T
Tao Luo 已提交
979 980 981 982 983
    cd ${PADDLE_ROOT}/build
    cp -r fluid_install_dir fluid
    tar -czf fluid.tgz fluid
    cp -r fluid_inference_install_dir fluid_inference
    tar -czf fluid_inference.tgz fluid_inference
984 985
}

986
function test_fluid_lib() {
T
Tao Luo 已提交
987
    cat <<EOF
988
    ========================================
989
    Testing fluid library for inference ...
990 991
    ========================================
EOF
T
Tao Luo 已提交
992 993 994 995 996
    cd ${PADDLE_ROOT}/paddle/fluid/inference/api/demo_ci
    ./run.sh ${PADDLE_ROOT} ${WITH_MKL:-ON} ${WITH_GPU:-OFF} ${INFERENCE_DEMO_INSTALL_DIR} \
             ${TENSORRT_INCLUDE_DIR:-/usr/local/TensorRT/include} \
             ${TENSORRT_LIB_DIR:-/usr/local/TensorRT/lib}
    ./clean.sh
997 998
}

T
tianshuo78520a 已提交
999 1000 1001 1002 1003 1004

function build_document_preview() {
    sh /paddle/tools/document_preview.sh ${PORT}
}


T
tianshuo78520a 已提交
1005
function example() {
1006
    pip install /paddle/build/python/dist/*.whl
T
tianshuo78520a 已提交
1007 1008
    paddle version
    cd ${PADDLE_ROOT}/python/paddle/fluid
1009
    python sampcd_processor.py cpu 
T
tianshuo78520a 已提交
1010 1011 1012 1013 1014 1015 1016
    if [ "$?" != "0" ];then
      echo "Code instance execution failed"
      exit 1
    fi
}


1017 1018
function main() {
    local CMD=$1
1019
    local parallel_number=$2
1020 1021
    init
    case $CMD in
1022 1023 1024 1025 1026 1027 1028 1029 1030
      build_only)
        cmake_gen ${PYTHON_ABI:-""}
        build ${parallel_number}
        ;;
      build_and_check)
        cmake_gen ${PYTHON_ABI:-""}
        build ${parallel_number}
        assert_api_not_changed ${PYTHON_ABI:-""}
        assert_api_spec_approvals
T
tianshuo78520a 已提交
1031
        example
1032
        ;;
1033 1034
      build)
        cmake_gen ${PYTHON_ABI:-""}
1035
        build ${parallel_number}
1036
        gen_dockerfile ${PYTHON_ABI:-""}
1037
        assert_api_spec_approvals
1038
        ;;
1039 1040
      combine_avx_noavx)
        combine_avx_noavx_build
1041
        gen_dockerfile ${PYTHON_ABI:-""}
1042 1043 1044
        ;;
      combine_avx_noavx_build_and_test)
        combine_avx_noavx_build
1045
        gen_dockerfile ${PYTHON_ABI:-""}
1046 1047
        parallel_test_base
        ;;
1048
      test)
1049
        parallel_test
1050
        ;;
1051 1052 1053
      single_test)
        single_test $2
        ;;
1054 1055 1056
      bind_test)
        bind_test
        ;;
1057 1058 1059
      gen_doc_lib)
        gen_doc_lib $2
        ;;
1060 1061 1062 1063
      html)
        gen_html
        ;;
      dockerfile)
1064
        gen_dockerfile ${PYTHON_ABI:-""}
1065 1066 1067
        ;;
      fluid_inference_lib)
        cmake_gen ${PYTHON_ABI:-""}
1068
        gen_fluid_lib ${parallel_number}
1069 1070
        tar_fluid_lib
        test_fluid_lib
1071 1072 1073 1074
        ;;
      check_style)
        check_style
        ;;
L
Lei Wang 已提交
1075 1076
      cicheck)
        cmake_gen ${PYTHON_ABI:-""}
1077
        build ${parallel_number}
1078
        parallel_test
L
Lei Wang 已提交
1079
        ;;
G
gongweibao 已提交
1080 1081
      cicheck_brpc)
        cmake_gen ${PYTHON_ABI:-""}
1082
        build ${parallel_number}
G
gongweibao 已提交
1083 1084
        run_brpc_test
        ;;
1085 1086
      assert_api)
        assert_api_not_changed ${PYTHON_ABI:-""}
Y
Yu Yang 已提交
1087
        assert_api_spec_approvals
1088 1089
        ;;
      test_inference)
1090
        gen_fluid_lib ${parallel_number}
1091 1092 1093 1094 1095
        test_fluid_lib
        ;;
      assert_api_approvals)
        assert_api_spec_approvals
        ;;
1096 1097 1098
      maccheck)
        cmake_gen ${PYTHON_ABI:-""}
        build_mac
L
lujun 已提交
1099
        run_mac_test ${PYTHON_ABI:-""} ${PROC_RUN:-1}
1100
        ;;
J
JiabinYang 已提交
1101 1102 1103 1104
      macbuild)
        cmake_gen ${PYTHON_ABI:-""}
        build_mac
        ;;
M
minqiyang 已提交
1105 1106
      cicheck_py35)
        cmake_gen ${PYTHON_ABI:-""}
1107
        build ${parallel_number}
1108
        parallel_test
M
minqiyang 已提交
1109
        ;;
Y
Yu Yang 已提交
1110 1111 1112 1113
      cmake_gen)
        cmake_gen ${PYTHON_ABI:-""}
        ;;
      gen_fluid_lib)
1114
        gen_fluid_lib ${parallel_number}
Y
Yu Yang 已提交
1115 1116 1117 1118
        ;;
      test_fluid_lib)
        test_fluid_lib
        ;;
T
tianshuo78520a 已提交
1119 1120 1121 1122 1123
      document)
        cmake_gen ${PYTHON_ABI:-""}
        build ${parallel_number}
        build_document_preview
        ;;
T
tianshuo78520a 已提交
1124 1125 1126
      api_example)
        example
        ;;
1127 1128
      *)
        print_usage
1129
        exit 1
1130 1131 1132 1133 1134
        ;;
      esac
}

main $@